/// <reference types="node" />
import WS from "ws";
import { EventEmitter } from "events";
import Telnet from "./telnet";
declare class WTClient extends EventEmitter {
    readonly UUID: string;
    private socket;
    readonly options: Telnet.TelnetOptionMatrix;
    private responder;
    constructor(socket: WS);
    close(code?: number, reason?: string): void;
    send(data: Buffer): void;
    send(data: string): void;
    private sendTelnet;
    sendSubnegotiation(option: Telnet.TelnetOption, data: Buffer): void;
    sendSubnegotiation(option: Telnet.TelnetOption, data: string): void;
    will(option: Telnet.TelnetOption): void;
    wont(option: Telnet.TelnetOption): void;
    do(option: Telnet.TelnetOption): void;
    dont(option: Telnet.TelnetOption): void;
    prompt(message: string, mask?: boolean): Promise<string>;
    private HandleData;
    on(event: "error", listener: (error: Error) => void): this;
    on(event: "message", listener: (data: string) => void): this;
    on(event: "close", listener: (code?: number, reason?: string) => void): this;
    on(event: "ping" | "pong", listener: (data?: Buffer) => void): this;
    on(event: "will" | "wont" | "do" | "dont", listener: (option: number) => void): this;
    on(event: "subnegotiation", listener: (option: number, data: Buffer) => void): this;
    on(event: "telnet", listener: (ev: Telnet.TelnetEvent) => void): this;
    on(event: "open", listener: () => void): this;
    emit(event: "error", error: Error): boolean;
    emit(event: "message", data: string): boolean;
    emit(event: "close", code?: number, reason?: string): boolean;
    emit(event: "ping" | "pong", data?: Buffer): boolean;
    emit(event: "will" | "wont" | "do" | "dont", option: number): boolean;
    emit(event: "subnegotiation", option: number, data: Buffer): boolean;
    emit(event: "telnet", ev: Telnet.TelnetEvent): boolean;
    emit(event: "open"): boolean;
}
export = WTClient;
